package university;

public class UpCastingDownCasting {
	public static void main(String[] args) {
		Person personRefVariable;
		Person tedPersonRefVariableStudentObj = new Student("Ted", 2, 2000, 4.0);
		Student studentRefVariable;
		GradStudent gradStudentRefVariable;

		/* Same variable type (compiler is OK with this assignment) */
		personRefVariable = tedPersonRefVariableStudentObj;

		/*
		 * Does not compile as the compiler does not know whether
		 * tedPersonRefVariableStudentObj is referring to a Person or a Student (it
		 * cannot see the assignment). Because tedPersonVariableStudentObj is of type
		 * Person, it could refer to either a Person object or a Student object. If it
		 * were to refer to a Person object, the assignment will not make sense (not
		 * every Person is a Student) StudentRefVariable = tedPersonRefVariableStudentObj;
		 */
		// StudentRefVariable = tedPersonRefVariableStudentObj;
		
		/*
		 * Downcasting: The code will compile as the type of variable on the left is the
		 * same (due to the casting) to the type of the expression on the right. Because
		 * tedPersonRefVariableStudentObj actually refers to a Student, there is no
		 * problem at run-time as treating an object that is a Student as a student
		 * makes sense.
		 */

		studentRefVariable = (Student) tedPersonRefVariableStudentObj;

		/*
		 * Downcasting: The code will compile as the type of variable on the left is the
		 * same (due to the casting) to the type of the expression on the right. At
		 * run-time a ClassCastException will be thrown as you cannot treat a Student as
		 * a GraduateStudent (not all students are graduate students. Remove the 
		 * comment from following line to see the ClassCastException
		 */

		 // gradStudentRefVariable = (GradStudent) tedPersonRefVariableStudentObj;

		/*
		 * To prevent the previous problem we need to check the type of the object using
		 * instanceof. The compiler can do some type checking using instanceof (e.g.,
		 * tedPersonRefVariableStudentObj instanceof String will not compile), but it is
		 * at run-time when instanceof looks at the object in order to determine its
		 * type Safe Downcasting:
		 */
		if (tedPersonRefVariableStudentObj instanceof GradStudent) {
			gradStudentRefVariable = (GradStudent) tedPersonRefVariableStudentObj;
		} else {
			System.err.println("Invalid cast operation");
		}
	}
}
